<?php
/*
Plugin Name: Yandex.Zen PostGrid
Plugin URI: https://wordpress.org/plugins/display-yandex-zen-postgrid/
Description: The plugin is needed to display the last posts from your Zen channel
Version: 0.4
Author: Popov Vladimir
Author URI: http://novatechno.ru/
License: GPL2
Text Domain: display-yandex-zen-postgrid
*/

//////////////////////////
/*Настройки*/
class YgSettings
{
	private $options;
	/* Start */
	public function __construct(){
		add_action('admin_menu', array($this, 'add_plugin_page'));
		add_action('admin_init', array($this, 'page_init'));
	}
	/* Add options page  */
	public function add_plugin_page(){
	   add_options_page("YandexGrid",__( 'Yandex.Zen PostGrid', 'display-yandex-zen-postgrid' ),'manage_options','yg-settings',array($this, 'create_admin_page'));
	}

	public function create_admin_page(){
		echo '<div id="dyzp">';
			echo '<div class="block">';
				echo '<form method="post" action="options.php">';
				$this->options = get_option('yg_option_name');
					settings_fields('yg_option_group');
					echo '<h2>'.__( 'Global options', 'display-yandex-zen-postgrid' ).'</h2>';
					echo '<table>';

						echo '<tr><td>'.__( 'Enable cache?','display-yandex-zen-postgrid' ).'</td><td> 
						<input type="checkbox" id="yg_zen_cash" name="yg_option_name[yg_zen_cash]" value="'.(boolval($this->options["yg_zen_cash"]) ? 'true' : 'false').'"'. checked((boolval($this->options["yg_zen_cash"]) ? 'true' : 'false'),'true',false). ' />
						<span style="font-size:10px; color:grey;"> | '.__( 'For delete cache, remove folder /cache/ in plugin folder','display-yandex-zen-postgrid' ).'</span>
						</td></tr>';

						echo '<tr><td>'.__( 'Publish WordPress as post?','display-yandex-zen-postgrid' ).'</td><td> 
						<input type="checkbox" id="yg_zen_post_create" name="yg_option_name[yg_zen_post_create]" value="'.(boolval($this->options["yg_zen_post_create"]) ? 'true' : 'false').'"'. checked((boolval($this->options["yg_zen_post_create"]) ? 'true' : 'false'),'true',false). ' />
						<span style="font-size:10px; color:grey;"> | '.__( 'Automatically publish all posts received from Yandex (draft) | only last 20','display-yandex-zen-postgrid' ).'</span>
						</td></tr>';

						echo '<tr><td>'.__( 'Enable Icon Dzen?','display-yandex-zen-postgrid' ).'</td><td> 
						<input type="checkbox" id="yg_zen_icon" name="yg_option_name[yg_zen_icon]" value="'.(boolval($this->options["yg_zen_icon"]) ? 'true' : 'false').'"'. checked((boolval($this->options["yg_zen_icon"]) ? 'true' : 'false'),'true',false). ' />
						</td></tr>';

						echo '<tr><td>'.__( 'AutoInsert after post content','display-yandex-zen-postgrid' ).'</td><td> 
						<input type="checkbox" id="yg_zen_auto" name="yg_option_name[yg_zen_auto]" value="'.(boolval($this->options["yg_zen_auto"]) ? 'true' : 'false').'"'. checked((boolval($this->options["yg_zen_auto"]) ? 'true' : 'false'),'true',false). ' />
						</td></tr>';

						echo '<tr><td>'.__( 'HTML code before auto insert', 'display-yandex-zen-postgrid' ).':</td><td style="display:block;" > 
						<textarea rows="3" cols="100" id="yg_zen_auto_before" name="yg_option_name[yg_zen_auto_before]" value="'.$this->options['yg_zen_auto_before'].'" />'.$this->options['yg_zen_auto_before'].'</textarea>
						</td></tr>';

					echo '</table>';
					submit_button(''.__( 'Save options', 'display-yandex-zen-postgrid' ).'');
				echo '</form>';
			echo '</div>';
			
			echo '<div class="block">';
				echo '<form method="post" action="options.php">';
					$this->options = get_option('yg_option_name2');
					settings_fields('yg_option_group2');
					echo '<h2>'.__( 'Generate Shortcode', 'display-yandex-zen-postgrid' ).'</h2>';
					echo '<table>';	
						echo '<tr><td>'.__( 'Yandex.Zen (ID or name)','display-yandex-zen-postgrid' ).':</td><td> 
						<input type="text" id="yg_zen_media" name="yg_option_name2[yg_zen_media]" value="'.$this->options['yg_zen_media'].'" />
						<span style="font-size:13px; color:grey;"> example: https://zen.yandex.ru/<b style="font-size:16px; color:red;">polygon</b></span></td></tr>';
						
						echo '<tr><td>'.__( 'Text','display-yandex-zen-postgrid' ).'</td><td> 
						<input type="checkbox" id="yg_zen_text" name="yg_option_name2[yg_zen_text]" value="'.(boolval($this->options["yg_zen_text"]) ? 'true' : 'false').'"'. checked((boolval($this->options["yg_zen_text"]) ? 'true' : 'false'),'true',false). ' />
						</td></tr>';

						echo '<tr><td>'.__( 'Text length (words)', 'display-yandex-zen-postgrid' ).':</td><td> 
						<input min="1" type="number" id="yg_zen_text_len" name="yg_option_name2[yg_zen_text_len]" value="'.$this->options['yg_zen_text_len'].'" />
						</td></tr>';

						echo '<tr><td>'.__( 'Posts', 'display-yandex-zen-postgrid' ).':</td><td> 
						<input min="1" type="number" id="yg_zen_сount" name="yg_option_name2[yg_zen_сount]" value="'.$this->options['yg_zen_сount'].'" />
						</td></tr>';

						echo '<tr><td>'.__( 'Columns', 'display-yandex-zen-postgrid' ).':</td><td> 
						<input min="1" max="6" type="number" id="yg_zen_col" name="yg_option_name2[yg_zen_col]" value="'.$this->options['yg_zen_col'].'" />
						</td></tr>';

					echo '</table> <hr>';
					submit_button(''.__( 'GetShortcode', 'display-yandex-zen-postgrid' ).'');
					echo __( 'Copy shortcode and place on your site', 'display-yandex-zen-postgrid' ). 
						'<h3>[zengrid id="'.$this->options['yg_zen_media'].'" text="'.($this->options['yg_zen_text']?'true':'false').'" textlen="'.$this->options['yg_zen_text_len'].'" count="'.$this->options['yg_zen_сount'].'" col="'.$this->options['yg_zen_col'].'"]</h3>';
				echo '</form>';
			echo '</div>';

			if($this->options['yg_zen_media']){
				echo '<div class="dyzp_preview">';
					echo '<h2>'.__( 'Preview shortcode', 'display-yandex-zen-postgrid' ).'</h2>';
					$atts = array('id' => $this->options['yg_zen_media'],'text' => $this->options['yg_zen_text'],'text_len' => $this->options['yg_zen_text_len'],'count' => $this->options['yg_zen_сount'],'col' =>$this->options['yg_zen_col']);
					$this->options = get_option('yg_option_name');
					echo get_option('yg_option_name')['yg_zen_auto_before'].YgZen_get_zen_grid($atts);
				echo '</div>';
			}
			
			echo '<div class="block">';	
				echo '<form method="post" action="options.php">';
					$this->options = get_option('yg_option_name3');
					settings_fields('yg_option_group3');
					echo '<h2>'.__( 'Parsing chanel', 'display-yandex-zen-postgrid' ).'</h2>';
					echo '<table>';	

						//Нужно спарсить канал
						if($this->options['yg_zen_parsing_kanal']!=''):
							$json_text = YgZenUtil::get_zen_json($this->options['yg_zen_parsing_kanal']);
							if(!empty($json_text)){
								$json_text = json_decode($json_text);
								$i=1;foreach ($json_text->items as $item) {
									$result = YgZen_parse_url($item->link,true);
									if(is_array($result) && $result['post_id']!=0){
										echo "<p>".$i." Добавлено: <a href='".get_the_permalink($result['post_id'])."'>".get_the_title($result['post_id'])."</a></p>";
										$i++;
										if($i>=$this->options['yg_zen_parsing_сount']) break;
									}
									else echo "<p>".__( 'Error. record already exists', 'display-yandex-zen-postgrid' )."</p>";
								}
								echo "<p>".__( 'Total added', 'display-yandex-zen-postgrid' ).": ".$i."</p>";
							}
						endif;

						//Нужно спарсить статью по URL
						if($this->options['yg_zen_parsing_url']!=''):
							$result = YgZen_parse_url($this->options['yg_zen_parsing_url'],true);
							if(is_array($result) && $result['post_id']!=0)
								echo "<p>".__( 'Added', 'display-yandex-zen-postgrid' ).": <a href='".get_the_permalink($result['post_id'])."'>".get_the_title($result['post_id'])."</a></p>";
							else echo "<p>".__( 'Record already exists', 'display-yandex-zen-postgrid' )."</p>";
						endif;

						$this->options['yg_zen_parsing_kanal'] ='';
						$this->options['yg_zen_parsing_сount'] = 1;
						$this->options['yg_zen_parsing_url'] ='';

						echo '<tr><td>'.__( 'ID or name for parsing','display-yandex-zen-postgrid' ).':</td><td> 
						<input type="text" id="yg_zen_parsing_kanal" name="yg_option_name3[yg_zen_parsing_kanal]" value="'.$this->options['yg_zen_parsing_kanal'].'" />
						<span style="font-size:13px; color:grey;"> example: https://zen.yandex.ru/<b style="font-size:16px; color:red;">polygon</b></span></td></tr>';

						echo '<tr><td>'.__( 'Count posts for parsing', 'display-yandex-zen-postgrid' ).':</td><td> 
						<input min="1" max="20" type="number" id="yg_zen_parsing_сount" name="yg_option_name3[yg_zen_parsing_сount]" value="'.$this->options['yg_zen_parsing_сount'].'" />
						</td></tr>';
						echo '</table><hr>';

						echo '<h2>'.__( 'Parsing one post', 'display-yandex-zen-postgrid' ).'</h2>';
						echo '<table>';	
							echo '<tr><td>'.__( 'Post url for parsing','display-yandex-zen-postgrid' ).':</td><td> 
							<input type="text" id="yg_zen_parsing_url" name="yg_option_name3[yg_zen_parsing_url]" value="'.$this->options['yg_zen_parsing_url'].'" />';

						echo '</table>';
						submit_button(''.__( 'Parsing start', 'display-yandex-zen-postgrid' ).'');
				echo '</form>';
			echo '</div>';
			echo '<div class="block">';
				echo '<h2>'.__( 'Partners link', 'display-yandex-zen-postgrid' ).'</h2>';
				echo '<p><a target="_blank" href="https://dachamaster.org">dachamaster.org - Дачный мастер</a></p>';
				echo '<p><a target="_blank" href="https://dc-m.ru/">dc-m.ru - Все о практическом интернет-маркетинге</a></p>';
				
				
			echo '</div>';
		echo '</div>';

			echo '<link rel="stylesheet" href="'.plugin_dir_url( __FILE__ ).'/admin-style.css'.'" />';
			echo '<link rel="stylesheet" href="'.plugin_dir_url( __FILE__ ).'/style.css'.'" />';
			
			
			

	}

	/* Регистрируем настройки*/
	public function page_init()
	{
		register_setting('yg_option_group','yg_option_name');
		register_setting('yg_option_group2','yg_option_name2');
		register_setting('yg_option_group3','yg_option_name3');

		add_settings_field('yg_zen_cash', '','yg-settings','yg_section_1' );
		add_settings_field('yg_zen_post_create', '','yg-settings','yg_section_1' );
		add_settings_field('yg_zen_post_icon', '','yg-settings','yg_section_1' );
		add_settings_field('yg_zen_post_auto', '','yg-settings','yg_section_1' );
		add_settings_field('yg_zen_auto_before', '','yg-settings','yg_section_1' );

		add_settings_field('yg_zen_media', '','yg-settings','yg_section_2' );
		add_settings_field('yg_zen_text', '','yg-settings','yg_section_2' );
		add_settings_field('yg_zen_text_len', '','yg-settings','yg_section_2' );
		add_settings_field('yg_zen_сount', '','yg-settings','yg_section_2' );
		add_settings_field('yg_zen_col', '','yg-settings','yg_section_2' );
		
		add_settings_field('yg_zen_parsing_kanal', '','yg-settings','yg_section_3' );
		add_settings_field('yg_zen_parsing_сount', '','yg-settings','yg_section_3' );
		add_settings_field('yg_zen_parsing_url', '','yg-settings','yg_section_3' );

	}
}

if( is_admin() ) 
	$my_settings_page = new YgSettings();

////////////////////////
/*ДзенУтилиты*/
class YgZenUtil {
	static function get_zen_json ($id="polygon") {
		$headers_name = get_headers("https://zen.yandex.ru/".$id, 1);
		$headers_id = get_headers("https://zen.yandex.ru/id/".$id, 1);
		if(strlen($id)>=24) 
			$flag = "id";
		else 
			$flag = "name";
			$url = 'https://zen.yandex.ru/api/v3/launcher/more?country_code=ru&channel_'.$flag.'=' . $id;
		$options = array('http'=>array('method'=>"GET",'header'=>"Accept-language: en\r\n"."User-Agent: Grid for Yandex.Zen (https://wordpress.org/..../)\r\n"));
		$context = stream_context_create($options);
		if($content = @file_get_contents($url, false, $context))
			return $content;
		else 
			return false;
	}
	//ПолучитьКэш
	function get_zen_cache($check_time, $id) {
		$cache_time = 1800; // 30 минут
		$cachefile = dirname( __FILE__ ) . '/cache/data-' . $id . '.txt';
		if (($check_time == false)||(file_exists($cachefile)&&(filesize($cachefile)>0)&&(time()-filemtime($cachefile)) < $cache_time)) {
			$fp = @fopen($cachefile, 'r');
			$data = fread($fp, filesize($cachefile));
			return $data;
		}
		return "";
	}

	//СохранитьКэш
	function save_zen_cache($data,$id) {
		if (empty ($data)) return;
		$cachedir = dirname( __FILE__ ) . '/cache';
		if (!file_exists($cachedir)) {
			mkdir($cachedir, 0777, true);
		}
		$cachefile = $cachedir . '/data-' . $id . '.txt';
		file_put_contents($cachefile, $data);
	}
}

//АвтоВставка после постов 
function YgZen_auto($content) {
	if(!is_feed() && strpos($_SERVER['REQUEST_URI'], 'feed') != true){
		global $post;
		$plug_options = get_option('yg_option_name');
		if(isset($plug_options['yg_zen_auto']) && $plug_options['yg_zen_auto']==true){
			$atts = array('id' => $plug_options['yg_zen_media'],'text' => get_option('yg_option_name2')['yg_zen_text'],'count' => $plug_options['yg_zen_сount'],'col' =>$plug_options['yg_zen_col']);
			$content.= $plug_options['yg_zen_auto_before'].YgZen_get_zen_grid($atts);
		}
	}
	return $content;
}
add_filter('the_content', 'YgZen_auto', 99 );

////////////////////
/*РАЗНОЕ*/
	function YgZen_get_zen_grid($atts) {
	if(!is_feed() && strpos($_SERVER['REQUEST_URI'], 'feed') != true){
		$plug_options = get_option('yg_option_name');
		$params = shortcode_atts( array( // в массиве укажите значения параметров по умолчанию
			'id' => 'polygon', // параметр 1
			'count' => '3', // параметр 2
			'col' => '3', // параметр 3
			'text' => 'false',
			'text_len' => '14', // параметр 4
			), $atts );
			$id_saveget=$params['id']."-".$params['count']."-".$params['col']."-".$params['text']."-".$params['text_len'];

			if (empty( $params['id'] )) 
				return __( 'Error', 'display-yandex-zen-postgrid' );

				$cache = YgZenUtil::get_zen_cache(true,$id_saveget);
			if (!empty ($cache) && $plug_options['yg_zen_cash']==true) 
				return $cache;

			$json_text = YgZenUtil::get_zen_json($params['id']);

			if (empty( $json_text )) 
				return  __( 'Error', 'display-yandex-zen-postgrid' );

			$json = json_decode($json_text);
			$count = count ($json->items);

			$div = '<link rel="stylesheet" href="'.plugin_dir_url(__FILE__).'style.css">';
			$div .= '<div class="zen-posts ' . ($plug_options['yg_zen_icon']==true?'icon':'') .'">';
			// TODO move in options
			
			$added = 0;
			for ($i = 0; $i < $count; $i++) {
				$last = $json->items[$i];
				$title = $last->title;
				$link = $last->link;
				$dzen_link="https://zen.yandex.ru/id/".$params['id'];

				if(strlen($params['id'])>=24) 
					$dzen_link = 'https://zen.yandex.ru/id/'.$params['id'];
				else 
					$dzen_link = 'https://zen.yandex.ru/'.$params['id'];


				$imgUrl = $last->image;
				$id = $last->id;

				if (parse_url($link, PHP_URL_HOST) != 'zen.yandex.ru') 
					continue;

				$url=parse_url($link);
				$url=$url['scheme'].'://'.$url['host'].$url['path'];

				if (empty($id)) 
					return YgZenUtil::get_zen_cache(false, $id_saveget);

				//Получаем контент статьи
				if($params['text']=='true'){
					$data_parse = YgZen_parse_url($url,$plug_options['yg_zen_post_create'],$params['text_len']);
				}
				$div .='<div style="background-image:url(' . $imgUrl. ')" class="zen-posts-col cols-'.$params['col'].'">';
					$div .= '<a class="link" href="' .$url. '" target="_blank">' .$title . '<span>'.($params['text']=='true'?$data_parse['excerpt']:'').'</span></a>';
					$div .= '<a href="'.$dzen_link.'" target="_blank" class="link_kanal">Перейти на канал</a>';
				$div .= '</div>';
					
				$added++;
				if ($added >= $count || $added >= $params['count']) 
					break;
			}
			$div .= '</div>';

			unset($post_light,$post_content,$html);


			if ($plug_options['yg_zen_cash']==true)
				YgZenUtil::save_zen_cache($div,$id_saveget);
			return $div;
		}
	}

add_shortcode( 'zengrid', 'YgZen_get_zen_grid' );

//Парсим ссылкку на дзене
function YgZen_parse_url($link,$post_in_wp = false,$text_len = 15){
	//Очистька урла
	$link=parse_url($link);
	$link=$link['scheme'].'://'.$link['host'].$link['path'];

	//Если урл не содержит zen.yandex.ru то выходим
	if (parse_url($link, PHP_URL_HOST) != 'zen.yandex.ru')
		return false;

		include_once plugin_dir_path( __FILE__ ).'/parser/simple_html_dom.php';
		$html = file_get_html($link);
		$title = $html->find('.article__title',0)->plaintext;
		$html = $html->find('div[itemprop=articleBody]',0);
		$imgs = [];


		//Получаем изображения
		foreach($html->find('figure') as $el){
			$img=$el->find('img',0)->getAttribute('src');
			$img_data=$el->find('img',0)->getAttribute('data-src');
			$img = ($img?$img:$img_data);
			if($img){
				$el->outertext = '<img src="'.$img.'">';
				$imgs[]=$img;
			}

		}
		
		//Получаем короткий текст статьи (первый абзатц)
		$post_light='';
		foreach($html->find('p') as $el){
			if($el->plaintext){
				$post_light.=$el->plaintext;
				if(strlen($post_light)>=$text_len*15){
					$post_light = wp_trim_words($post_light, $text_len);
					break;
				} 
			}
		}

		//Удаляем атрибуты и получаем контент для публикации на сайте
		$html = $html->outertext;
		$post_content = YgZen_remove_attributes($html, ['src','data-scr']);

		//Публикуем посты
		$post_id=0;
		if($post_in_wp && $title){
			$post = get_posts(['post_type'=>'post','post_status'=>'any','posts_per_page'=> 1,'meta_key'=>'ygzenkey','meta_value'=>$link,'meta_compare'=>'=']);
			if(isset($post[0])===false){

				$i=0;foreach ($imgs as $img) {$i++;
					$img_new=YgZen_upload_image_in_wp($img,false);
					$post_content = str_ireplace([$img,'<div>','</div>'],[$img_new,'',''],htmlspecialchars_decode($post_content));
				}


				$post_data = array(
					'post_title'    => $title,
					'post_content'  => $post_content,
					'post_status'   => 'draft',
					'post_author'   => 1,
					'meta_input'    => [ 'ygzenkey'=>$link],
				);
				$post_id = wp_insert_post( $post_data );
			}
		}
		return ['excerpt'=>$post_light,'post_id'=>$post_id];
} 


function YgZen_remove_attributes($text, $allowed = [])
{
	$attributes = implode('|', $allowed);
	$reg = '/(<[\w]+)([^>]*)(>)/i';
	$text = preg_replace_callback(
		$reg,
		function ($matches) use ($attributes) {
			// Если нет разрешенных атрибутов, возвращаем пустой тег
			if (!$attributes) {
				return $matches[1] . $matches[3];
			}

			$attr = $matches[2];
			$reg = '/(' . $attributes . ')="[^"]*"/i';
			preg_match_all($reg, $attr, $result);
			$attr = implode(' ', $result[0]);
			$attr = ($attr ? ' ' : '') . $attr;

			return $matches[1] . $attr . $matches[3];
		},
		$text
	);

	return $text;
}

//Загрузка файла в WP и вернём id файла
function YgZen_upload_image_in_wp($url,$thumb=false) {
	// во фронтэнде нужны эти файлы
	require_once ABSPATH . 'wp-admin/includes/image.php';
	require_once ABSPATH . 'wp-admin/includes/file.php';
	require_once ABSPATH . 'wp-admin/includes/media.php';
	// Загрузить WebP-файл
	$im = @imagecreatefromjpeg($url);
	if(empty($im))
		$im = @imagecreatefrompng($url);
	elseif(empty($im))
		$im = @imagecreatefromwebp($url);

	$upload_dir = (object) wp_upload_dir();
	$img_path = $upload_dir->basedir.'/ygzen/'.md5($url).'.png';
	$img_url = $upload_dir->baseurl.'/ygzen/'.md5($url).'.png';
	
	if (!file_exists($upload_dir->basedir.'/ygzen/')) 
		mkdir($upload_dir->basedir.'/ygzen/', 0755, true);

	// Сконвертировать его в jpeg-файл со 100%-качеством
	imagealphablending($im, false);
 	imagesavealpha($im, true);
	if(imagepng($im, $img_path))
		return $img_url;
	else 
		return false;
}

